# CoPaR, the `Co`algebraic `Pa`rtition `R`efiner


## Building

    stack build

Alternatively, you can directly download the [latest binaries for
linux](https://git8.cs.fau.de/software/copar/-/jobs/artifacts/master/download?job=test).

Enabling the flag `benchmark-generators` also build generators and helper
executables used to create various benchmark suites that have been used in
different publications. To build with that flag, use the command `stack build
--flag copar:benchmark-generators`.

## Running

To partition states of a coalgebra specification, use the command

    stack exec -- copar refine FILENAME
    
Examples for input files are in the directory `examples/`.

Command line syntax is described in `copar --help` and the input
file syntax in `copar help`.

## Benchmarks

Extensive benchmarks of CoPaR on different input files can be found at
[git8.cs.fau.de/software/copar-benchmarks](https://git8.cs.fau.de/software/copar-benchmarks).

Micro-Benchmarks for internal data structures and routines are available in the
`bench/` directory and can be executed with `stack bench`.

## API documentation

The documentation for the internal API can be built and opened in the
default browser with:

    stack haddock --open copar

This can help to understand the code structure.
