module Main where

import Criterion.Main

import qualified Copar.Coalgebra.BenchParser
import qualified Copar.Functors.BenchGroupValued
import qualified Copar.Parser.BenchLexer
import qualified Data.List.BenchUtils
import qualified Copar.Algorithm.BenchInitialize
import qualified Data.BenchRefinablePartition
import qualified Data.BenchBlockQueue
import qualified Data.BenchSumBag

main :: IO ()
main = defaultMain
  [ Copar.Coalgebra.BenchParser.benchmarks
  , Copar.Functors.BenchGroupValued.benchmarks
  , Copar.Parser.BenchLexer.benchmarks
  , Data.List.BenchUtils.benchmarks
  , Copar.Algorithm.BenchInitialize.benchmarks
  , Data.BenchRefinablePartition.benchmarks
  , Data.BenchBlockQueue.benchmarks
  , Data.BenchSumBag.benchmarks
  ]
