module Data.List.BenchUtils (benchmarks) where

import Criterion

import Control.Monad.ST

import Data.List.Utils

benchmarks :: Benchmark
benchmarks = bgroup "Data.List.Utils"
  [ benchDeleteLargestM
  ]

benchDeleteLargestM :: Benchmark
benchDeleteLargestM = bgroup "deleteLargestM"
  [ bench "5" $ nf (deleteLargestM Just) [1,4,2,5,0]
  , bench "10" $ nf (deleteLargestM Just) [1,4,2,5,40,3,6,9,30,7]
  , bench "100" $ nf (deleteLargestM Just) [0..100]
  , bench "200" $ nf (deleteLargestM Just) [0..200]
  , bench "st 5" $ nfIO (stToIO $ deleteLargestM return [1,4,2,5,0])
  , bench "st 100" $ nfIO (stToIO $ deleteLargestM return [0..100])
  , bench "st 1000" $ nfIO (stToIO $ deleteLargestM return [0..1000])
  , bench "st 2000" $ nfIO (stToIO $ deleteLargestM return [0..2000])
  , bench "st 3000" $ nfIO (stToIO $ deleteLargestM return [0..3000])
  ]
