# Profiling CoPaR

This document explains how to analyze the performance of CoPaR with profiling.


## Compile

To get useful profiling results, it might be necessary to comment out *every*
`INLINE` pragma in the whole source code.

Cabal makes compiling with profiling very easy:

    cabal build --enable-profiling

This build both CoPaR and all dependencies with profiling information.

## Run

You have to explicitly enable profiling in the run-time system with `+RTS -p` as
last argument if you want to generate profiling output:

    cabal exec copar -- ARGS +RTS -p

This will generate a file called `copar.prof`.

## Analyze

There are a view tools to visualize this profiling file. One of them is
`viewprof`, a terminal UI:

    cabal install viewprof
    viewprof copar.prof

Another one is `profiteur`, which generates an interactive HTML file that can be
viewed in a browser:

    cabal install profiteur
    profiteur copar.prof
    firefox copar.prof.html
