module Copar.FunctorExpression.Transform (transform) where

import           Copar.FunctorExpression.Type

-- | Apply a bottom-up transformation all functors in the expression.
--
-- Since this function always gets whole subtrees, it can rewrite the AST
-- arbitrarily.
transform
  :: Functor f
  => (f (FunctorExpression g a) -> g (FunctorExpression g a))
  -> FunctorExpression f a
  -> FunctorExpression g a
transform _ Variable = Variable
transform f (Functor a inner) = Functor a (f (fmap (transform f) inner))
