{-# LANGUAGE ConstraintKinds #-}
{-# LANGUAGE PolyKinds #-}
module Copar.FunctorExpression.Type
  ( FunctorExpression(..)
  ) where

import Data.Functor.Classes

data FunctorExpression f a
  = Functor a (f (FunctorExpression f a))
  | Variable

deriving instance Functor f => Functor (FunctorExpression f)
deriving instance Foldable f => Foldable (FunctorExpression f)
deriving instance Traversable f => Traversable (FunctorExpression f)

instance (Show a, Show1 f) => Show (FunctorExpression f a) where
  showsPrec _    Variable      = ("Variable" ++)
  showsPrec prec (Functor a f) = maybeParen
    prec
    (("Functor " ++) . showsPrec 11 a . (' ' :) . showsPrec1 11 f)
    where
      maybeParen prec s | prec > 10 = ('(' :) . s . (')' :)
                        | otherwise = s

instance (Eq a, Eq1 f) => Eq (FunctorExpression f a) where
  Variable        == Variable        = True
  (Functor a1 f1) == (Functor a2 f2) = a1 == a2 && eq1 f1 f2
  _               == _               = False
