{-# LANGUAGE PolyKinds #-}

module Copar.Functors (registeredFunctors) where

import           Prelude                 hiding ( product )

import           Copar.FunctorDescription
import           Copar.Functors.Bag             ( Bag )
import           Copar.Functors.Distribution    ( Distribution )
import           Copar.Functors.GroupValued     ( IntValued
                                                , RealValued
                                                , ComplexValued
                                                , RationalValued
                                                )
import           Copar.Functors.Polynomial      ( Polynomial )
import           Copar.Functors.Powerset        ( Powerset )
import           Copar.Functors.MonoidValued    ( MaxIntValued
                                                , MinIntValued 
                                                , MaxDoubleValued
                                                , MinDoubleValued
                                                , BitAndValued
                                                , BitOrValued
                                                )

registeredFunctors :: [DynFunctorDescription]
registeredFunctors =    
  [ dynFunctorDescription @MaxIntValued
  , dynFunctorDescription @MinIntValued
  , dynFunctorDescription @MaxDoubleValued
  , dynFunctorDescription @MinDoubleValued
  , dynFunctorDescription @BitAndValued
  , dynFunctorDescription @BitOrValued

  , dynFunctorDescription @IntValued
  , dynFunctorDescription @RealValued
  , dynFunctorDescription @ComplexValued
  , dynFunctorDescription @RationalValued

  , dynFunctorDescription @Powerset
  , dynFunctorDescription @Bag
  , dynFunctorDescription @Distribution

  , dynFunctorDescription @Polynomial
  ]
