{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE TemplateHaskell #-}

-- | Type definitions used by both refinable and immutable partitions.
module Data.Partition.Common
  ( State
  , Block(..)
  ) where

import           Unsafe.Coerce

import           Control.DeepSeq (NFData)
import           Data.Vector.Unboxed.Deriving

import           Data.MorphismEncoding (State)

-- | A block is represented by an integer.
--
-- Blocks in a partition always start at zero.
newtype Block = Block { fromBlock :: Int }
  deriving (Eq,Ord,Num,Enum,NFData)

instance Show Block where
  show (Block b) = show b

derivingUnbox "Block"
  [t| Block -> Int |]
  [| unsafeCoerce |]
  [| unsafeCoerce |]
