module Data.Vector.Utils
  ( iforM_
  , sort
  , sortBy
  , sortOn
  , hasDuplicates
  ) where

import           Data.Ord (comparing)

import           Data.Vector (Vector)
import qualified Data.Vector as V
import qualified Data.Vector.Algorithms.Intro as V

iforM_ :: Monad m => Vector a -> (Int -> a -> m b) -> m ()
iforM_ = flip V.imapM_

sort :: Ord a => Vector a -> Vector a
sort = V.modify V.sort


-- FIXME: There should be inline pragmas for sortBy and sortOn, but GHC panics
-- when I do this.

sortBy :: (a -> a -> Ordering) -> Vector a -> Vector a
sortBy predicate = V.modify (V.sortBy predicate)


sortOn :: Ord b => (a -> b) -> Vector a -> Vector a
sortOn f = V.modify (V.sortBy (comparing f))


hasDuplicates :: Eq a => Vector a -> Bool
hasDuplicates v = V.length (V.uniq v) /= V.length v
{-# INLINE hasDuplicates #-}
