{-# LANGUAGE TemplateHaskell #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FunctionalDependencies #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE DeriveFunctor #-}

module Mdp.Types
  ( Mdp(Mdp)
  , Transition(Transition)
  , numStates
  , numChoices
  , transitions
  , source
  , choice
  , target
  , probability
  , action
  , HasNumStates
  , HasNumChoices
  , HasTransitions
  , HasSource
  , HasChoice
  , HasTarget
  , HasProbability
  , HasAction
  ) where

import           Data.Vector                    ( Vector )
import           Data.Text                      ( Text )
import           Lens.Micro.Platform

data Mdp p = Mdp
  { mdpNumStates :: Int
  , mdpNumChoices :: Int
  , mdpTransitions :: Vector (Transition p)
  } deriving (Show, Functor)

-- TODO Support optional action label
data Transition p = Transition
  { transitionSource :: Int
  , transitionChoice :: Int
  , transitionTarget :: Int
  , transitionProbability :: p
  , transitionAction :: Maybe Text
  } deriving (Show, Functor)

makeFields ''Mdp
makeFields ''Transition
