module CoalgOutput (coalgB) where

import           Data.Foldable                  ( fold )
import           Data.List                      ( intersperse )
import           Data.Word

import qualified Data.Text.Lazy.Builder        as Build
import qualified Data.Text.Lazy.Builder.Int    as Build
import           Lens.Micro.Platform

import           Type


coalgB :: DFA -> Build.Builder
coalgB dfa = functorB dfa <> "\n\n" <> transitionsB dfa


functorB :: DFA -> Build.Builder
functorB dfa = "{True,False}xX^" <> Build.decimal (dfa ^. letters)


transitionsB :: DFA -> Build.Builder
transitionsB dfa = foldMap (forStateB dfa) [0 .. dfa ^. states - 1]


forStateB :: DFA -> Word32 -> Build.Builder
forStateB dfa n =
  "s"
    <> Build.decimal n
    <> ": ("
    <> Build.fromString (show (dfa ^?! isFinal . ix (fromIntegral n)))
    <> ", {"
    <> fold
         (intersperse
           ", "
           (zipWith successorB
                    [0 ..]
                    (dfa ^.. transitions . ix (fromIntegral n) . each)
           )
         )
    <> "})\n"


successorB :: Word32 -> Word32 -> Build.Builder
successorB label target = Build.decimal label <> ": s" <> Build.decimal target
