# Random Weighted Tree Automata

This directory contains a command line tool to generate random weighted tree
automata for the monoids `(Word, or)`, `(Z, max)` and `(Bool, or)`, the latter
being used as powerset throughout the code.

The generated automata are coalgebras for the functor `M×M^(ΣX)`, where `M` is
the monoid and `ΣX` is a polynomial that can be configured with the `--symbols`
parameter.

The generator supports two output formats. By default, CoPaRs own syntax is used
and optionally (only for powerset), the format understood by the code at [1] can
be generated.

## Usage

Please see the output of `random-wta --help`. By default, automata with 70% zero
transitions are generated, but the number of transitions can be freely
configured with the `--zero-frequency` and `--transitions` parameters.


[1]: https://people.cs.umu.se/~johanna/bisimulation/
