module Copar.Functors.PowersetSpec (spec) where

import           Test.Hspec
import           Test.Hspec.Megaparsec
import           TestHelpers

import           Copar.Functors.Powerset
import           Copar.Coalgebra.Parser
import           Copar.FunctorExpression.Type
import           Copar.FunctorExpression.Sorts (Sorted(..))


spec :: Spec
spec = do
  parseMorphismPointSpec

parseMorphismPointSpec :: Spec
parseMorphismPointSpec = describe "parseMorphismPoint" $ do
  it "works for a simple example" $
    (snd <$> parseMorphisms (Functor 1 (Powerset Variable)) EnableSanityChecks "" "x: {x, y}\ny: {}") `shouldParse`
    (encoding
       [(Sorted 1 True), (Sorted 1 False)]
       [(0, (Sorted 1 ()), 0), (0, (Sorted 1 ()), 1)])

  it "errors on duplicate edges" $
    parseMorphisms (Functor 1 (Powerset Variable)) EnableSanityChecks "" `shouldFailOn` "x: {x, x}"
