module Data.Float.UtilsSpec (spec) where

import Test.Hspec
import Test.QuickCheck

import Data.Float.Utils

spec :: Spec
spec = do
  maxDoubleSpec

maxDoubleSpec :: Spec
maxDoubleSpec = describe "maxDouble" $ do
  describe "Semigroup <>" $ do
    it "is associative" $ property $ \(a :: MaxDouble) b c ->
      a <> (b <> c) === (a <> b) <> c

  describe "Monoid mempty" $ do
    it "is left identity" $ property $ \(x :: MaxDouble) ->
      not (isNaN x) ==> (mempty <> x === x)

    it "is right identity" $ property $ \(x :: MaxDouble) ->
      not (isNaN x) ==> x <> mempty === x

instance Arbitrary MaxDouble where
  arbitrary = MaxDouble <$> arbitrary
