{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE DataKinds #-}
module Data.OpenUnionSpec (spec) where

import Test.Hspec

import Data.OpenUnion

type TestUnion = Union '[Maybe, []]

-- Monomorphic versions of inj and prj
inj' :: Member x '[Maybe, []] => x () -> TestUnion ()
inj' = inj

prj' :: Member x '[Maybe, []] => TestUnion () -> Maybe (x ())
prj' = prj

spec :: Spec
spec = describe "proj" $ do
  it "is the inverse of inj" $ do
    prj' (inj' (Just ())) `shouldBe` (Just (Just ()))
    prj' (inj' [()]) `shouldBe` (Just [()])

  it "retuns Nothing when trying to extract the wrong type" $ do
    prj' @[] (inj' (Just ())) `shouldBe` Nothing
    prj' @Maybe (inj' [()]) `shouldBe` Nothing


